Package net.sf.saxon.query

## Class ImportedFunctionLibrary

- java.lang.Object
- - net.sf.saxon.query.ImportedFunctionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`, `XQueryFunctionBinder`

      public class ImportedFunctionLibrary
      extends java.lang.Object
      implements FunctionLibrary, XQueryFunctionBinder

  This implementation of FunctionLibrary contains all the functions imported into a Query Module. It is implemented as a view of the "global" XQueryFunctionLibrary for the whole query, selecting only those functions that are in an imported namespace.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ImportedFunctionLibrary​(QueryModule importingModule, XQueryFunctionLibrary baseLibrary)` | Create an imported function library

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addImportedNamespace​(java.lang.String namespace)` | Add an imported namespace
    `Expression` | `bind​(SymbolicName.F symbolicName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `XQueryFunction` | `getDeclaration​(StructuredQName functionName, int staticArgs)` | Get the function declaration corresponding to a given function name and arity
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available
    `void` | `setImportingModule​(QueryModule importingModule)` | Set the module that imports this function libary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### ImportedFunctionLibrary

          public ImportedFunctionLibrary​(QueryModule importingModule,
                                         XQueryFunctionLibrary baseLibrary)

      Create an imported function library
      Parameters:
        `importingModule` - the module importing the library
        `baseLibrary` - the function library of which this is a subset view

  - ### Method Detail

    - #### addImportedNamespace

          public void addImportedNamespace​(java.lang.String namespace)

      Add an imported namespace
      Parameters:
        `namespace` - the imported namespace

    - #### bind

          public Expression bind​(SymbolicName.F symbolicName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `symbolicName` - the name of the function to be bound
        `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

        The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

        `env` - The static context of the function call
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An object representing the function to be called, if one is found; null if no function was found matching the required name and arity.

    - #### getDeclaration

          public XQueryFunction getDeclaration​(StructuredQName functionName,
                                               int staticArgs)

      Get the function declaration corresponding to a given function name and arity
      Specified by:
        `getDeclaration` in interface `XQueryFunctionBinder`
      Parameters:
        `functionName` - the name of the function as a QName
        `staticArgs` - the number of expressions supplied as arguments in the function call
      Returns:
        the XQueryFunction if there is one, or null if not.

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.

    - #### setImportingModule

          public void setImportingModule​(QueryModule importingModule)

      Set the module that imports this function libary
      Parameters:
        `importingModule` - the importing module

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling